# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EdgeGateway::Mgmt::V2019_03_01
  module Models
    #
    # Details about ongoing updates and availability of updates on the device.
    #
    class UpdateSummary < ARMBaseModel

      include MsRestAzure

      # @return [String] The current version of the device in format:
      # 1.2.17312.13.",
      attr_accessor :device_version_number

      # @return [String] The current version of the device in text format.
      attr_accessor :friendly_device_version_name

      # @return [DateTime] The last time when a scan was done on the device.
      attr_accessor :device_last_scanned_date_time

      # @return [DateTime] The time when the last scan job was completed
      # (success/cancelled/failed) on the appliance.
      attr_accessor :last_completed_scan_job_date_time

      # @return [DateTime] The time when the last Download job was completed
      # (success/cancelled/failed) on the appliance.
      attr_accessor :last_completed_download_job_date_time

      # @return [DateTime] The time when the last Install job was completed
      # (success/cancelled/failed) on the appliance.
      attr_accessor :last_completed_install_job_date_time

      # @return [Integer] The number of updates available for the current
      # device version as per the last device scan.
      attr_accessor :total_number_of_updates_available

      # @return [Integer] The total number of items pending download.
      attr_accessor :total_number_of_updates_pending_download

      # @return [Integer] The total number of items pending install.
      attr_accessor :total_number_of_updates_pending_install

      # @return [InstallRebootBehavior] Indicates if updates are available and
      # at least one of the updates needs a reboot. Possible values include:
      # 'NeverReboots', 'RequiresReboot', 'RequestReboot'
      attr_accessor :reboot_behavior

      # @return [UpdateOperation] The current update operation. Possible values
      # include: 'None', 'Scan', 'Download', 'Install'
      attr_accessor :ongoing_update_operation

      # @return [String] The job ID of the download job in progress.
      attr_accessor :in_progress_download_job_id

      # @return [String] The job ID of the install job in progress.
      attr_accessor :in_progress_install_job_id

      # @return [DateTime] The time when the currently running download (if
      # any) started.
      attr_accessor :in_progress_download_job_started_date_time

      # @return [DateTime] The time when the currently running install (if any)
      # started.
      attr_accessor :in_progress_install_job_started_date_time

      # @return [Array<String>] The list of updates available for install.
      attr_accessor :update_titles

      # @return [Float] The total size of updates available for download in
      # bytes.
      attr_accessor :total_update_size_in_bytes


      #
      # Mapper for UpdateSummary class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UpdateSummary',
          type: {
            name: 'Composite',
            class_name: 'UpdateSummary',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              device_version_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deviceVersionNumber',
                type: {
                  name: 'String'
                }
              },
              friendly_device_version_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.friendlyDeviceVersionName',
                type: {
                  name: 'String'
                }
              },
              device_last_scanned_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deviceLastScannedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_completed_scan_job_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastCompletedScanJobDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_completed_download_job_date_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastCompletedDownloadJobDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_completed_install_job_date_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastCompletedInstallJobDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              total_number_of_updates_available: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.totalNumberOfUpdatesAvailable',
                type: {
                  name: 'Number'
                }
              },
              total_number_of_updates_pending_download: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.totalNumberOfUpdatesPendingDownload',
                type: {
                  name: 'Number'
                }
              },
              total_number_of_updates_pending_install: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.totalNumberOfUpdatesPendingInstall',
                type: {
                  name: 'Number'
                }
              },
              reboot_behavior: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.rebootBehavior',
                type: {
                  name: 'String'
                }
              },
              ongoing_update_operation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.ongoingUpdateOperation',
                type: {
                  name: 'String'
                }
              },
              in_progress_download_job_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.inProgressDownloadJobId',
                type: {
                  name: 'String'
                }
              },
              in_progress_install_job_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.inProgressInstallJobId',
                type: {
                  name: 'String'
                }
              },
              in_progress_download_job_started_date_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.inProgressDownloadJobStartedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              in_progress_install_job_started_date_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.inProgressInstallJobStartedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              update_titles: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.updateTitles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              total_update_size_in_bytes: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.totalUpdateSizeInBytes',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
